/*

    Copyright 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023, 2024  joshua.tee@gmail.com

    This file is part of wX.

    wX is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    wX is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with wX.  If not, see <http://www.gnu.org/licenses/>.

 */

package joshuatee.wx.common

@Suppress("SpellCheckingInspection")
object GlobalArrays {

    val nwsImageProducts = listOf(
        "RAD_2KM: Radar Mosaic",
        "GOES16: GOES16 product last viewed",
        "VIS_CONUS: Visible CONUS",
        "CONUSWV: US Water Vapor",
        "SND: Sounding/Hodograph",
        "USWARN: US Warning map",
        "AKWARN: AK Warning map",
        "HIWARN: HI Warning map",
        "FMAP: National Forecast Chart Day 1",
        "FMAPD2: National Forecast Chart Day 2",
        "FMAPD3: National Forecast Chart Day 3",
        "FMAP12: WPC Fronts/NDFD Weather Type - 12hr",
        "FMAP24: WPC Fronts/NDFD Weather Type - 24hr",
        "FMAP36: WPC Fronts/NDFD Weather Type - 36hr",
        "FMAP48: WPC Fronts/NDFD Weather Type - 48hr",
        "FMAP72: WPC Fronts/NDFD Weather Type - 72hr",
        "FMAP96: WPC Fronts/NDFD Weather Type - 96hr",
        "FMAP120: WPC Fronts/NDFD Weather Type - 120hr",
        "FMAP144: WPC Fronts/NDFD Weather Type - 144hr",
        "FMAP168: WPC Fronts/NDFD Weather Type - 168hr",
        "FMAP3D: Forecast map - 3day",
        "FMAP4D: Forecast map - 4day",
        "FMAP5D: Forecast map - 5day",
        "FMAP6D: Forecast map - 6day",
        "LTG: Lightning map",
        "SWOD1: SPC Convective Outlook Day 1",
        "SWOD2: SPC Convective Outlook Day 2",
        "SWOD3: SPC Convective Outlook Day 3",
        "STRPT: SPC Storm reports for today",
        "SPC_TST: SPC Thunderstorm Outlook",
        "QPF1: QPF Day 1",
        "QPF2: QPF Day 2",
        "QPF3: QPF Day 3",
        "QPF1-2: QPF Day 1-2",
        "QPF1-3: QPF Day 1-3",
        "QPF4-5: QPF Day 4-5",
        "QPF6-7: QPF Day 6-7",
        "QPF1-5: QPF 5 Day Total",
        "QPF1-7: QPF 7 Day Total",
        "SPCMESO1: Favorite #1 (500mb)",
        "SPCMESO2: Favorite #2 (pmsl)",
        "SPCMESO3: Favorite #3 (ttd)",
        "SPCMESO4: Favorite #4 (rgnlrad)",
        "SPCMESO5: Favorite #5 (lllr)",
        "SPCMESO6: Favorite #6 (laps)",
        "WPC_ANALYSIS: WPC Analysis, Radar, Warnings",
        "NHC2ATL: ATL Two-Day Graphical Tropical Weather Outlook",
        "NHC5ATL: ATL Seven-Day Graphical Tropical Weather Outlook",
        "NHC2EPAC: EPAC Two-Day Graphical Tropical Weather Outlook",
        "NHC5EPAC: EPAC Seven-Day Graphical Tropical Weather Outlook",
        "NHC2CPAC: CPAC Two-Day Graphical Tropical Weather Outlook",
        "NHC5CPAC: CPAC Five-Day Graphical Tropical Weather Outlook"
    )

//    val radars = listOf(
//        "ABC: AK, Bethel",
//        "APD: AK, Fairbanks/Pedro Dome",
//        "AHG: AK, Kenai",
//        "AKC: AK, King Salmon",
//        "AIH: AK, Middleton Island",
//        "AEC: AK, Nome",
//        "ACG: AK, Sitka/Biorka Island",
//        "BMX: AL, Birmingham",
//        "EOX: AL, Fort Rucker",
//        "HTX: AL, Huntsville",
//        "MXX: AL, Maxwell AFB",
//        "MOB: AL, Mobile",
//        "SRX: AR, Fort Smith",
//        "LZK: AR, Little Rock",
//        "FSX: AZ, Flagstaff",
//        "IWA: AZ, Phoenix",
//        "EMX: AZ, Tucson",
//        "YUX: AZ, Yuma",
//        "BBX: CA, Beale AFB",
//        "EYX: CA, Edwards AFB",
//        "BHX: CA, Eureka",
//        "VTX: CA, Los Angeles",
//        "DAX: CA, Sacramento",
//        "NKX: CA, San Diego",
//        "MUX: CA, San Francisco",
//        "HNX: CA, San Joaquin Valley",
//        "SOX: CA, Santa Ana Mountains",
//        "VBX: CA, Vandenberg AFB",
//        "FTG: CO, Denver",
//        "GJX: CO, Grand Junction",
//        "PUX: CO, Pueblo",
//        "DOX: DE, Dover AFB",
//        "EVX: FL, Eglin AFB",
//        "JAX: FL, Jacksonville",
//        "BYX: FL, Key West",
//        "MLB: FL, Melbourne",
//        "AMX: FL, Miami",
//        "TLH: FL, Tallahassee",
//        "TBW: FL, Tampa",
//        "FFC: GA, Atlanta",
//        "VAX: GA, Moody AFB",
//        "JGX: GA, Robins AFB",
//        "GUA: GU, Andersen AFB",
//        "HKI: HI, Kauai",
//        "HKM: HI, Kohala",
//        "HMO: HI, Molokai",
//        "HWA: HI, South Shore",
//        "DVN: IA, Davenport",
//        "DMX: IA, Des Moines",
//        "CBX: ID, Boise",
//        "SFX: ID, Pocatello/Idaho Falls",
//        "LOT: IL, Chicago",
//        "ILX: IL, Lincoln",
//        "VWX: IN, Evansville",
//        "IND: IN, Indianapolis",
//        "IWX: IN, North Webster",
//        "DDC: KS, Dodge City",
//        "GLD: KS, Goodland",
//        "TWX: KS, Topeka",
//        "ICT: KS, Wichita",
//        "HPX: KY, Fort Campbell",
//        "JKL: KY, Jackson",
//        "LVX: KY, Louisville",
//        "PAH: KY, Paducah",
//        "POE: LA, Fort Polk",
//        "HDC: LA, Hammond",      // to Begin NEXRAD Level III Product Dissemination on or around March 31, 2024 Service Change Notice 24-11
//        "LCH: LA, Lake Charles",
//        "LIX: LA, New Orleans",  // GONE as of late 2023
//        "SHV: LA, Shreveport",
//        "BOX: MA, Boston",
//        "CBW: ME, Loring AFB",
//        "GYX: ME, Portland",
//        "DTX: MI, Detroit/Pontiac",
//        "APX: MI, Gaylord",
//        "GRR: MI, Grand Rapids",
//        "MQT: MI, Marquette",
//        "DLH: MN, Duluth",
//        "MPX: MN, Minneapolis/St. Paul",
//        "EAX: MO, Kansas City",
//        "SGF: MO, Springfield",
//        "LSX: MO, St. Louis",
//        "DGX: MS, Brandon/Jackson",
//        "GWX: MS, Columbus AFB",
//        "BLX: MT, Billings",
//        "GGW: MT, Glasgow",
//        "TFX: MT, Great Falls",
//        "MSX: MT, Missoula",
//        "KSG: NA, Camp Humphreys, South Korea",
//        "ODN: NA, Kadena Air Base, Japan",
//        "KJK: NA, Kunsan Air Base, South Korea",
//        "PLA: NA, Lajes Field, Azores",
//        "MHX: NC, Morehead City",
//        "RAX: NC, Raleigh/Durham",
//        "LTX: NC, Wilmington",
//        "BIS: ND, Bismarck",
//        "MVX: ND, Grand Forks (Mayville)",
//        "MBX: ND, Minot AFB",
//        "UEX: NE, Grand Island/Hastings",
//        "LNX: NE, North Platte",
//        "OAX: NE, Omaha",
//        "ABX: NM, Albuquerque",
//        "FDX: NM, Cannon AFB",
//        "HDX: NM, Holloman AFB",
//        "LRX: NV, Elko",
//        "ESX: NV, Las Vegas",
//        "RGX: NV, Reno",
//        "ENX: NY, Albany",
//        "BGM: NY, Binghamton",
//        "BUF: NY, Buffalo",
//        "TYX: NY, Montague",
//        "OKX: NY, New York City",
//        "CLE: OH, Cleveland",
//        "ILN: OH, Wilmington",
//        "FDR: OK, Frederick",
//        "TLX: OK, Oklahoma City",
//        "INX: OK, Tulsa",
//        "VNX: OK, Vance AFB",
//        "MAX: OR, Medford",
//        "PDT: OR, Pendleton",
//        "RTX: OR, Portland",
//        "DIX: PA, Philadelphia",
//        "PBZ: PA, Pittsburgh",
//        "CCX: PA, State College",
//        "JUA: PR, San Juan",
//        "CLX: SC, Charleston",
//        "CAE: SC, Columbia",
//        "GSP: SC, Greer",
//        "ABR: SD, Aberdeen",
//        "UDX: SD, Rapid City",
//        "FSD: SD, Sioux Falls",
//        "MRX: TN, Knoxville/Tri Cities",
//        "NQA: TN, Memphis",
//        "OHX: TN, Nashville",
//        "AMA: TX, Amarillo",
//        "EWX: TX, Austin/San Antonio",
//        "BRO: TX, Brownsville",
//        "CRP: TX, Corpus Christi",
//        "FWS: TX, Dallas/Ft. Worth",
//        "DYX: TX, Dyess AFB",
//        "EPZ: TX, El Paso",
//        "GRK: TX, Fort Hood",
//        "HGX: TX, Houston/Galveston",
//        "DFX: TX, Laughlin AFB",
//        "LBB: TX, Lubbock",
//        "MAF: TX, Midland/Odessa",
//        "SJT: TX, San Angelo",
//        "ICX: UT, Cedar City",
//        "MTX: UT, Salt Lake City",
//        "AKQ: VA, Norfolk/Richmond",
//        "FCX: VA, Roanoke",
//        "LWX: VA, Sterling",
//        "CXX: VT, Burlington",
//        "LGX: WA, Langley Hill",
//        "ATX: WA, Seattle/Tacoma",
//        "OTX: WA, Spokane",
//        "GRB: WI, Green Bay",
//        "ARX: WI, La Crosse",
//        "MKX: WI, Milwaukee",
//        "RLX: WV, Charleston",
//        "CYS: WY, Cheyenne",
//        "RIW: WY, Riverton"
//    )

//    val tdwrRadars = listOf(
//        "TPHX: AZ, Phoenix",
//        "TDEN: CO, Denver",
//        "TFLL: FL, Fort Lauderdale",
//        "TMIA: FL, Miami",
//        "TMCO: FL, Orlando International",
//        "TTPA: FL, Tampa Bay",
//        "TPBI: FL, West Palm Beach",
//        "TATL: GA, Atlanta",
//        "TMDW: IL, Chicago Midway",
//        "TORD: IL, Chicago O'Hare",
//        "TIDS: IN, Indianapolis",
//        "TICH: KS, Wichita",
//        "TSDF: KY, Louisville",
//        "TMSY: LA, New Orleans",
//        "TBOS: MA, Boston",
//        "TBWI: MD, Baltimore/Wash",
//        "TDCA: MD, Washington National",
//        "TDTW: MI, Detroit",
//        "TMSP: MN, Minneapolis",
//        "TMCI: MO, Kansas City",
//        "TSTL: MO, St Louis",
//        "TCLT: NC, Charlotte",
//        "TRDU: NC, Raleigh Durham",
//        "TEWR: NJ, Newark",
//        "TLAS: NV, Las Vegas",
//        "TJFK: NY, New York City",
//        "TLVE: OH, Cleveland",
//        "TCMH: OH, Columbus",
//        "TCVG: OH, Covington",
//        "TDAY: OH, Dayton",
//        "TOKC: OK, Oklahoma City",
//        "TTUL: OK, Tulsa",
//        "TPHL: PA, Philadelphia",
//        "TPIT: PA, Pittsburgh",
//        "TSJU: PR, San Juan",
//        "TMEM: TN, Memphis",
//        "TBNA: TN, Nashville",
//        "TDFW: TX, Dallas/Ft. Worth",
//        "TDAL: TX, Dallas Love Field",
//        "THOU: TX, Houston Hobby",
//        "TIAH: TX, Houston International",
//        "TSLC: UT, Salt Lake City",
//        "TIAD: VA, Dulles",
//        "TMKE: WI, Milwaukee"
//    )

    val states = listOf(
        "AL: Alabama",
        "AK: Alaska",
        "AZ: Arizona",
        "AR: Arkansas",
        "CA: California",
        "CO: Colorado",
        "CT: Connecticut",
        "DE: Delaware",
        "FL: Florida",
        "GA: Georgia",
        "HI: Hawaii",
        "ID: Idaho",
        "IL: Illinois",
        "IN: Indiana",
        "IA: Iowa",
        "KS: Kansas",
        "KY: Kentucky",
        "LA: Louisiana",
        "ME: Maine",
        "MD: Maryland",
        "MA: Massachusetts",
        "MI: Michigan",
        "MN: Minnesota",
        "MS: Mississippi",
        "MO: Missouri",
        "MT: Montana",
        "NE: Nebraska",
        "NV: Nevada",
        "NH: New Hampshire",
        "NJ: New Jersey",
        "NM: New Mexico",
        "NY: New York",
        "NC: North Carolina",
        "ND: North Dakota",
        "OH: Ohio",
        "OK: Oklahoma",
        "OR: Oregon",
        "PA: Pennsylvania",
        "RI: Rhode Island",
        "SC: South Carolina",
        "SD: South Dakota",
        "TN: Tennessee",
        "TX: Texas",
        "UT: Utah",
        "VT: Vermont",
        "VA: Virginia",
        "WA: Washington",
        "WV: West Virginia",
        "WI: Wisconsin",
        "WY: Wyoming"
    )
}
